
layui.define(function (exports) {
	var $ = layui.$,
		layer = layui.layer,
		element = layui.element,
		setter = layui.setter,
		message = new Messenger('index', 'kdayunmanager');
	var common = {

		/**
		 * 判断是否为空 
		 * 字符串,null,undefined,[],{}
		 * @param {*} obj 
		 */
		isEmpty(obj) {
			if (obj === null) {
				return true
			}
			if (obj === undefined) {
				return true
			}
			if (obj === '') {
				return true
			}
			if (obj['length'] === 0) {
				return true
			}
			if (obj === {}) {
				return true
			}
			return false
		},
		/**
		 * 抛出一个异常错误信息
		 * @param {String} msg
		 */
		throwError: function (msg) {
			throw new Error(msg);
			return;
		},
		/**
		 * 弹出一个错误提示
		 * @param {String} msg
		 */
		msgError: function (msg) {
			layer.msg(msg, {
				icon: 5
			});
			return;
		},
		/**
		 * 给url增加参数
		 * @param {*} url url
		 * @param {*} obj  参数对象
		 * @param {*} exclude  排除的属性名的正则表达式
		 * @returns 返回url
		 */
		setUrlParamObj: function (url, obj, exclude) {
			for (var pro in obj) {
				if (exclude) {
					if (!exclude.test(pro)) {
						url = common.setUrlParam(url, pro, obj[pro]);
					}
				} else {
					url = common.setUrlParam(url, pro, obj[pro]);
				}
			}
			return url;
		},
		/**
		 * 给url增加参数
		 * @param {*} url URL
		 * @param {*} name 参数名
		 * @param {*} value  参数值
		 * @returns 返回url
		 */
		setUrlParam: function (url, name, value) {
			var localUrl = url;
			if (value != null) {
				//增加或修改url参数
				//判断URL是否带有?号
				if (localUrl.indexOf("?") < 0) {
					//判断url是否有#
					var a = localUrl.indexOf("#");
					if (a < 0) {
						return localUrl + "?" + name + "=" + value;
					} else {
						return localUrl.substring(0, a) + "?" + name + "=" + value + localUrl.substring(a);
					}

				} else {
					var regex = new RegExp("([\\?&]" + name + "=)[^&#]*");
					if (regex.test(localUrl)) {
						return localUrl.replace(regex, "$1" + value);
					}
					else {
						var a = localUrl.indexOf("#");
						if (a < 0) {
							return localUrl + "&" + name + "=" + value;
						} else {
							return localUrl.substring(0, a) + "&" + name + "=" + value + localUrl.substring(a);
						}
					}
				}
			} else {
				//删除url的参数
				var regex = new RegExp("([\\?&])" + name + "=[^&#]*(&?)");
				if (regex.test(localUrl)) {
					return localUrl.replace(regex, function (m, p1, p2) {
						if (p1 == "?") {
							return p2 == "&" ? "?" : "";
						} else {
							return p2;
						}
					});
				} else {
					return localUrl;
				}

			}

		},
		tabsPage: {},

		setPrevAndNext: function () {
			var $li = $('.layui-tab-title').children('li')
				, sumwidth = 0
				, totalwidth = $('.layui-tab-title').width();
			for (var i = 0; i < $li.length; i++) {
				sumwidth = sumwidth + $li.eq(i).outerWidth();
			}
			if (sumwidth > totalwidth) {
				$('.layadmin-pagetabs').css({ "padding-left": "40px", "padding-right": "80px" });
				$('.layui-icon-prev').show();
				$('.layui-icon-next').show();
			} else {
				$('.layadmin-pagetabs').css({ "padding-left": "0px", "padding-right": "40px" });
				$('.layui-icon-prev').hide();
				$('.layui-icon-next').hide();
			}
		},
		/**
		 * 打开tab标签页
		 * @param {*} url 页签的URL
		 * @param {*} text 页签的标题
		 * @param {*} resid 资源id
		 * @param {*} param 传递的参数
		 * @param {*} callback 完成回调
		 */
		openTabsPage: function (url, text, resid, param, callback) {
			//遍历页签选项卡
			var matchTo, tabs = $('#LAY_app_tabsheader>li'),
				path = url.replace(/(^http(s*):)|(\?[\s\S]*$)/g, ''),
				tempresid = resid ? resid : url;
			if (url.indexOf('isnewtab=1') > -1) {
				window.open(url, "_blank");
				callback && callback();
				return;
			}

			url = common.setUrlParamObj(url, param, /tokenId/)
			if (!common.isEmpty(resid)) {
				url = common.setUrlParamObj(url, { resId: resid }, /tokenId/)
			}

			tabs.each(function (index) {
				var li = $(this),
					layid = li.attr('lay-id');
				if (layid === tempresid) {
					matchTo = true;
					common.tabsPage.index = index;
				}
			});
			var APP_BODY = '#LAY_app_body',
				FILTER_TAB_TBAS = 'layadmin-layout-tabs',
				text = text || '新标签页';
			//如果未在选项卡中匹配到，则追加选项卡
			if (!matchTo) {
				$(APP_BODY).append([
					'<div class="layadmin-tabsbody-item layui-show">',
					'<iframe src="' + url + '" frameborder="0" menuid=' + resid + ' class="layadmin-iframe" name="layadmin-iframe"></iframe>',
					'</div>'
				].join(''));
				common.tabsPage.index = tabs.length;
				element.tabAdd(FILTER_TAB_TBAS, {
					title: '<span>' + text + '</span>',
					id: resid ? resid : url,
					attr: path
				});
				common.setPrevAndNext();
				$('.layadmin-tabsbody-shade').show();
			}
			var $iframe
			if (path.indexOf('/coremodelshow') != -1 && resid) {
				$iframe = $(APP_BODY).find('iframe[menuid="' + resid + '"]');
			}
			else {
				$iframe = $(APP_BODY).find('iframe[src="' + url + '"]');
			}
			$iframe && !$iframe.attr('loaded') && $iframe.load(function () {
				if (url.indexOf('http:') != -1 || url.indexOf('https:') != -1) {
					$('.layadmin-tabsbody-shade').fadeOut('600');
				}
				$iframe.attr('loaded', 'true')
			});
			callback && callback();

			//执行 {setter.MOD_NAME}.tabsPage 下的事件
			layui.event.call(this, setter.MOD_NAME, 'tabsPage({*})', {
				url: tempresid,
				text: text
			});
		},
		/**
		 * xss 转义
		 * @param {*} html 
		 */
		escape: function (html) {
			return String(html || '').replace(/&(?!#?[a-zA-Z0-9]+;)/g, '&amp;')
				.replace(/</g, '&lt;').replace(/>/g, '&gt;')
				.replace(/'/g, '&#39;').replace(/"/g, '&quot;');
		},
		/**
		 * 打开Layer页
		 * @param {*} pageCoinfg 
		 * @param {*} params 
		 * @param {*} successCallback 页面完成打开回调
		 */
		openLayerPage: function (pageCoinfg, params, successCallback) {
			var pageId = params.__pageId;
			//页面创建加载完成
			pageId && common.onForm(pageId, 'onPageLoad', function (msg) {
				let iframes = top.window.document.getElementsByTagName("iframe");
				for (var i = 0; i < iframes.length; i++) {
					var iframe = iframes[i];
					if (iframe.contentWindow.location.href.indexOf('=' + pageId) != -1) {
						common.sendTo(pageId, 'onSuccess')
						break;
					}
				}
			})
			var p = $.extend(pageCoinfg, {
				type: 2,
				area: pageCoinfg.area || ['420px', '240px'],
				success: ($elem) => {
					$elem && $elem.focus();
					successCallback && successCallback();
				}
				, yes: () => {
					pageId && common.sendTo(pageId, 'onYes')
				}
				, cancel: () => {
					pageId && common.sendTo(pageId, 'onCancel')
				}
				, btn2: () => {
					pageId && common.sendTo(pageId, 'onCancel')
				}
				, end: () => {
					pageId && common.sendTo(pageId, 'onEnd')
				}
				, onCanClose: () => {
					return pageId && common.sendTo(pageId, 'onCanClose')
				}
				, onClosed: () => {
					pageId && common.sendTo(pageId, 'onClosed')
				}, full: () => {
					pageId && common.sendTo(pageId, 'onFull')
				}, min: () => {
					pageId && common.sendTo(pageId, 'onMin')
				}, resizing: () => {
					pageId && common.sendTo(pageId, 'onResizing')
				}, moveEnd: () => {
					pageId && common.sendTo(pageId, 'onMoveEnd')
				}, restore: () => {
					pageId && common.sendTo(pageId, 'onRestore')
				}
			});
			layer.open(p);
		},


		/**
		 * 监听消息(不管来源哪里)
		 * @param {*} msg  消息标识常量
		 * @param {*} callback  回调 callback(msg)
		 */
		on: function (msg, callback) {
			return message.on(msg, callback)
		},
		/**
		 * 监听消息(只管来源fromHandle 的消息)
		 * @param fromHandle 消息来源目标的句柄全局唯一
		 * @param {*} msg  消息标识常量
		 * @param {*} callback  回调 callback(msg)
		 */
		onForm: function (fromHandle, msg, callback) {
			if (!fromHandle) {
				throw new Error("fromHandle参数不允许为空")
			}
			return message.onFrom(fromHandle, msg, callback)
		},

		/**
		 * 给具体的目标发送消息
		 * @param {*} toHandle  目标句柄全局唯一
		 * @param {*} msg  消息标识常量is
		 * @param {*} params 附带的消息信息
		 */
		sendTo: function (toHandle, msg, params) {
			if (!toHandle) {
				throw new Error("toHandle参数不允许为空")
			}
			return message.sendTo(toHandle, msg, params);
		},

		/**
		 * 本iframe内给所有的目标发送消息
		 * @param {*} msg  消息标识常量
		 * @param {*} params  附带的消息信息
		 */
		send: function (msg, params) {
			var msgobj = {
				msg: msg,
				params: params
			}
			return message.send(msgobj);
		},
		/**
		 * 跨iframe给所有的目标发送消息
		 * @param {*} msg  消息标识常量
		 * @param {*} params  附带的消息信息
		 */
		broadcast: function (msg, params) {
			var msgobj = {
				msg: msg,
				params: params
			}
			return message.broadcast(msgobj);
		}
	}

	//对外暴露的接口
	exports('common', common);
});